package com.seuic.d400.d400settingdemo;

import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;

import android.app.AlertDialog;
import android.app.Fragment;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.method.ScrollingMovementMethod;
import android.text.style.ForegroundColorSpan;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

/**
 * A simple {@link Fragment} subclass.
 */
public class FragmentScanner extends Fragment implements View.OnClickListener {
	private View currentView;

	private Context mContext;

	private TextView mTvAcceptDatas;
	private TextView mTvCurrentState;
	private ListView mLvDevices;
	private Button mBtnDisconn;
	private Button mBtnOpen;
	private Button mBtnSearch;

	private List<BluetoothDevice> mDataList;
	private D400ListViewAdapter mAdapter;

	private BluetoothAdapter mBluetoothAdapter;
	private BluetoothSocket clientSocket;

	private String address;

	private AcceptThread acceptThread;

	private ConnectThread connectThread;

	private SharedPreferences sp;
	private SharedPreferences.Editor editor;

	private List<String> mAcceptList;

	private final String[] errodata = new String[] { "01", "02", "03", "04" };
	private boolean SwIsChecked = false;
	private int checktype = -1;
	private int checklength = 0;
	private int erro = 0;

	/**
	 * 协议类型
	 */
	private int protocol = D400Helper.SPP;

	/**
	 * 主线程handler
	 */
	private Handler mHandler = new Handler() {
		public void handleMessage(android.os.Message msg) {
			switch (msg.what) {
			case D400Helper.ACCEPTDATAS:
				byte[] news = (byte[]) msg.obj;
				HashMap<String, Object> map = CRCVerify.bytesToMap(news);
				String newstr = null;
				String order = null;
				String result = null;
				// Toast.makeText(mContext, "收到数据：" + new String(news),
				// Toast.LENGTH_SHORT).show();
				if (map != null) {
					newstr = (String) map.get("datas");
					order = (String) map.get("order");
					result = (String) map.get("result");
					// Toast.makeText(mContext, "收到数据集：" + map.toString(),
					// Toast.LENGTH_SHORT).show();
				} else {

					Toast.makeText(mContext, mContext.getResources().getString(R.string.fault_len), Toast.LENGTH_SHORT)
							.show();
					// connectThread.writeCallBack.callback(1);
					mTvAcceptDatas.setText("erro");
					// Toast.makeText(MainActivity.this, "收到错误的数据："+new
					// String(news), Toast.LENGTH_SHORT).show();
					break;
				}

				/**
				 * 接到条码数据
				 */
				if (order.equals("02")) {
					if (SwIsChecked) {
						if (checktype == 0) {
							if (mAcceptList.contains(newstr)) {
								Toast.makeText(mContext, mContext.getResources().getString(R.string.repeat),
										Toast.LENGTH_SHORT).show();
								connectThread.writeData(CRCVerify.ReqToBytes("03", "01", errodata[erro - 1]));
							} else /*
									 * if (!newstr.equals("R1") &&
									 * !newstr.equals("R2") &&
									 * !newstr.equals("R3") &&
									 * !newstr.equals("R4"))
									 */ {
								mAcceptList.add(newstr.trim());
							}
						} else if (checktype == 1) {
							if (newstr.length() != checklength
							/*
							 * && !newstr.equals("R1") && !newstr.equals("R2")
							 * && !newstr.equals("R3") && !newstr.equals("R4")
							 */) {
								Toast.makeText(mContext, mContext.getResources().getString(R.string.faul_code),
										Toast.LENGTH_SHORT).show();
								connectThread.writeData(CRCVerify.ReqToBytes("03", "01", errodata[erro - 1]));
							}
						}

					}

					String oldstr = mTvAcceptDatas.getText().toString();
					String d = new SimpleDateFormat("HH:mm:ss").format(Calendar.getInstance().getTime());
					SpannableString spannableString = new SpannableString(newstr);
					spannableString.setSpan(new ForegroundColorSpan(Color.BLUE), 0, spannableString.length(),
							Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
					// Intent intent = new Intent()
					if (protocol == D400Helper.SPP) {
						mTvAcceptDatas.setText(
								oldstr.toString()/* +newstr.toString() */);
						mTvAcceptDatas.append(d);
						mTvAcceptDatas.append("\t\t\t\t\t\t");
						mTvAcceptDatas.append(spannableString);
						mTvAcceptDatas.append("\n");
						int offset = mTvAcceptDatas.getLineCount() * mTvAcceptDatas.getLineHeight();
						if (offset > mTvAcceptDatas.getHeight()) {
							mTvAcceptDatas.scrollTo(0, offset - mTvAcceptDatas.getHeight());
						}

					} else {
						mTvAcceptDatas.setText(newstr);
					}

					// Toast.makeText(MainActivity.this, "收到数据：" + newstr,
					// Toast.LENGTH_SHORT).show();

				} else if (order.equals("01")) {
					Toast.makeText(mContext, mContext.getResources().getString(R.string.ring_ver) + newstr,
							Toast.LENGTH_SHORT).show();
				} else if (order.equals("05")) {
					if (newstr.equals("F0")) {

						Toast.makeText(mContext, mContext.getResources().getString(R.string.battle_charge),
								Toast.LENGTH_SHORT).show();

					} else if (newstr.equals("0F")) {
						Toast.makeText(mContext, mContext.getResources().getString(R.string.battle_ok),
								Toast.LENGTH_SHORT).show();
					}
				} else if (order.equals("07")) {
					if (result.equals("00")) {

						connectThread.writeCallBack.callback(D400Helper.SUFFIXSECCESS);
					} else {

						connectThread.writeCallBack.callback(D400Helper.SUFFIXFAIL);
					}
				} else if (order.equals("09")) {

					if (result.equals("00")) {

						connectThread.writeCallBack.callback(D400Helper.PREFIXSECCESS);
					} else {

						connectThread.writeCallBack.callback(D400Helper.PREFIXFAIL);
					}

				} else if (order.equals("0B")) {

					if (result.equals("00")) {

						connectThread.writeCallBack.callback(D400Helper.SOUNDSECCESS);
					} else {

						connectThread.writeCallBack.callback(D400Helper.SOUNDFAIL);
					}

				} else if (order.equals("0D")) {

					if (result.equals("00")) {

						connectThread.writeCallBack.callback(D400Helper.VIBRATESECCESS);
					} else {
						connectThread.writeCallBack.callback(D400Helper.VIBRATEFAIL);
					}

				} else if (order.equals("0F")) {

					if (result.equals("00")) {

						connectThread.writeCallBack.callback(D400Helper.SNSECCESS);
					} else {
						connectThread.writeCallBack.callback(D400Helper.SNFAIL);
					}

				} else if (order.equals("11")) {
					Toast.makeText(mContext, "SN：" + newstr, Toast.LENGTH_SHORT).show();
					connectThread.writeCallBack.callback(D400Helper.READSNSECCESS, newstr);
				} else if (order.equals("1B")) {
					if (result.equals("00")) {
						connectThread.settingCallBack.callback(D400Helper.SETTINGSECCESS);
					} else {
						connectThread.settingCallBack.callback(D400Helper.SETTINGFAIL);
					}
				}

				break;

			case D400Helper.CONNECTFAIL:
				// Toast.makeText(MainActivity.this, "连接失败！",
				// Toast.LENGTH_SHORT)
				// .show();
				mTvCurrentState.setText(mContext.getResources().getString(R.string.con_fail));
				break;
			case D400Helper.CONNECTSUCCESS:
				// Toast.makeText(MainActivity.this, "连接成功！",
				// Toast.LENGTH_SHORT)
				// .show();
				mTvCurrentState.setText(mContext.getResources().getString(R.string.con_suc));

				acceptThread = new AcceptThread(clientSocket, mHandler);
				acceptThread.start();

				mAdapter = new D400ListViewAdapter();
				mLvDevices.setAdapter(mAdapter);

				break;
			default:
				break;
			}
		}

	};

	/**
	 * 接收广播
	 */
	private final BroadcastReceiver mReceiver = new BroadcastReceiver() {

		public void onReceive(Context context, Intent intent) {
			String action = intent.getAction();

			// 发现设备
			if (BluetoothDevice.ACTION_FOUND.equals(action)) {
				// 从Intent中获取设备对象
				BluetoothDevice device = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
				// 将设备名称和地址放入list，以便在ListView中显示
				if (!mDataList.contains(device)) {
					mDataList.add(device);
					mAdapter.notifyDataSetChanged();
				}
			} else if (BluetoothAdapter.ACTION_DISCOVERY_FINISHED.equals(action)) {
				// 搜索完毕
				mTvCurrentState.setText(mContext.getResources().getString(R.string.searched));

			} else if (BluetoothAdapter.ACTION_DISCOVERY_STARTED.equals(action)) {
				mTvCurrentState.setText(mContext.getResources().getString(R.string.searching));
			} else if (BluetoothDevice.ACTION_BOND_STATE_CHANGED.equals(action)) {
				mTvCurrentState.setText(mContext.getResources().getString(R.string.status_change));
				BluetoothDevice device = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
				switch (device.getBondState()) {
				case BluetoothDevice.BOND_BONDING:
					mTvCurrentState.setText(mContext.getResources().getString(R.string.pairing));
					break;
				case BluetoothDevice.BOND_BONDED:
					mTvCurrentState.setText(mContext.getResources().getString(R.string.pairing_com));
					mAdapter.notifyDataSetChanged();
					if (null != clientSocket && clientSocket.isConnected()) {
						connectThread.cancel();

					}
					connectThread = new ConnectThread(device);// 连接设备
					connectThread.start();
					break;
				case BluetoothDevice.BOND_NONE:
					mTvCurrentState.setText(mContext.getResources().getString(R.string.pairing_cancle));
					mAdapter.notifyDataSetChanged();
					break;

				default:
					break;

				}
			} else if (BluetoothAdapter.ACTION_CONNECTION_STATE_CHANGED.equals(action)) {
				int state = (Integer) intent.getExtras().get(BluetoothAdapter.EXTRA_CONNECTION_STATE);
				mTvCurrentState.setText(mContext.getResources().getString(R.string.link_status_change));
				switch (state) {

				case BluetoothAdapter.STATE_CONNECTED:
					mTvCurrentState.setText(mContext.getResources().getString(R.string.connected));
					mAdapter.notifyDataSetChanged();

					// mSpProtocol.setSelection(1);

					break;
				case BluetoothAdapter.STATE_CONNECTING:
					mTvCurrentState.setText(mContext.getResources().getString(R.string.connecting));
					break;
				case BluetoothAdapter.STATE_DISCONNECTED:
					mTvCurrentState.setText(mContext.getResources().getString(R.string.disConnected));
					address = "";
					mAdapter.notifyDataSetChanged();
					// mSpProtocol.setSelection(0);
					break;
				case BluetoothAdapter.STATE_DISCONNECTING:
					mTvCurrentState.setText(mContext.getResources().getString(R.string.disConnecting));
					break;

				default:
					break;
				}
			} else if (BluetoothAdapter.ACTION_STATE_CHANGED.equals(action)) {
				mTvCurrentState.setText(mContext.getResources().getString(R.string.bt_status_ch));
				int state = (Integer) intent.getExtras().get(BluetoothAdapter.EXTRA_STATE);
				switch (state) {
				case BluetoothAdapter.STATE_ON:
					mTvCurrentState.setText(mContext.getResources().getString(R.string.bt_open));

					mBtnOpen.setText(mContext.getResources().getString(R.string.close));
					mBtnSearch.setEnabled(true);
					break;
				case BluetoothAdapter.STATE_TURNING_ON:
					mTvCurrentState.setText(mContext.getResources().getString(R.string.bt_openning));
					break;
				case BluetoothAdapter.STATE_OFF:
					mTvCurrentState.setText(mContext.getResources().getString(R.string.bt_close));
					mBtnOpen.setText(mContext.getResources().getString(R.string.open));
					mBtnSearch.setEnabled(false);
					mDataList.clear();
					mAdapter.notifyDataSetChanged();
					break;
				case BluetoothAdapter.STATE_TURNING_OFF:
					mTvCurrentState.setText(mContext.getResources().getString(R.string.bt_closiing));
					break;

				default:
					break;
				}
			}
		}
	};

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

		currentView = inflater.inflate(R.layout.scanner_layout, null);
		mContext = getActivity();

		mAcceptList = new ArrayList<String>();
		sp = mContext.getSharedPreferences("D400settings", Context.MODE_PRIVATE);
		SwIsChecked = sp.getBoolean("SwIsChecked", false);
		erro = sp.getInt("erro", 0);
		checklength = sp.getInt("checklength", 0);
		checktype = sp.getInt("checktype", 0);

		// 注册BroadcastReceiver
		IntentFilter filter = new IntentFilter(BluetoothDevice.ACTION_FOUND);
		filter.addAction(BluetoothAdapter.ACTION_DISCOVERY_FINISHED);
		filter.addAction(BluetoothAdapter.ACTION_DISCOVERY_STARTED);
		filter.addAction(BluetoothDevice.ACTION_BOND_STATE_CHANGED);
		filter.addAction(BluetoothAdapter.ACTION_CONNECTION_STATE_CHANGED);
		filter.addAction(BluetoothAdapter.ACTION_STATE_CHANGED);
		// Toast.makeText(mContext, "reg", Toast.LENGTH_SHORT).show();
		mContext.registerReceiver(mReceiver, filter); // 不要忘了之后解除绑定

		initView();
		initBluetooth();
		initData();

		return currentView;
	}

	private void initData() {
		if (mBluetoothAdapter == null) {
			return;
		}
		if (!mBluetoothAdapter.isEnabled()) {
			mBtnOpen.setText(mContext.getResources().getString(R.string.open));
			mBtnSearch.setEnabled(false);
			mTvCurrentState.setText(mContext.getResources().getString(R.string.dev_closed));
		} else {
			mBtnOpen.setText(mContext.getResources().getString(R.string.close));
			mTvCurrentState.setText(mContext.getResources().getString(R.string.dev_opened));
			mBtnSearch.setEnabled(true);
			mBluetoothAdapter.startDiscovery();
		}
	}

	private void initView() {

		mTvAcceptDatas = (TextView) currentView.findViewById(R.id.edit_scanner);
		mTvAcceptDatas.setMovementMethod(ScrollingMovementMethod.getInstance());
		mTvAcceptDatas.setOnLongClickListener(new View.OnLongClickListener() {
			@Override
			public boolean onLongClick(View v) {
				final AlertDialog dialog = new AlertDialog.Builder(getActivity())
						.setNegativeButton(mContext.getResources().getString(R.string.bfCancel), null)
						.setPositiveButton(mContext.getResources().getString(R.string.bfOK),
								new DialogInterface.OnClickListener() {

					@Override
					public void onClick(DialogInterface dialog, int which) {
						mTvAcceptDatas.scrollTo(0, 0);
						mTvAcceptDatas.setText("");
					}
				}).setMessage(mContext.getResources().getString(R.string.data_clean)).create();
				dialog.show();
				return true;
			}
		});

		mTvCurrentState = (TextView) currentView.findViewById(R.id.txt_state);

		mBtnDisconn = (Button) currentView.findViewById(R.id.btn_disconn);
		mBtnSearch = (Button) currentView.findViewById(R.id.btn_search);
		mBtnOpen = (Button) currentView.findViewById(R.id.btn_open);

		mBtnDisconn.setOnClickListener(this);
		mBtnSearch.setOnClickListener(this);
		mBtnOpen.setOnClickListener(this);

		mDataList = new ArrayList<BluetoothDevice>();
		mLvDevices = (ListView) currentView.findViewById(R.id.lv_devices);
		mAdapter = new D400ListViewAdapter();
		mLvDevices.setAdapter(mAdapter);
		mLvDevices.setOnItemClickListener(new AdapterView.OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				Log.d("Message", "click");
				if (clientSocket != null && clientSocket.isConnected()) {
					Toast.makeText(mContext, mContext.getResources().getString(R.string.close_con), Toast.LENGTH_SHORT)
							.show();
					return;
				}
				if (mBluetoothAdapter.isDiscovering()) {
					mBluetoothAdapter.cancelDiscovery();
				}

				BluetoothDevice btDev = mBluetoothAdapter.getRemoteDevice(mDataList.get(position).getAddress());
				try {
					if (btDev.getBondState() == BluetoothDevice.BOND_NONE) {
						// 利用反射方法调用BluetoothDevice.createBond(BluetoothDevice
						// remoteDevice);
						Method createBondMethod = BluetoothDevice.class.getMethod("createBond");
						createBondMethod.invoke(btDev);

					} else if (btDev.getBondState() == BluetoothDevice.BOND_BONDED) {
						mTvCurrentState.setText(mContext.getResources().getString(R.string.con_pre));

						connectThread = new ConnectThread(btDev);// 连接
						connectThread.start();
						address = mDataList.get(position).getAddress();
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});

	}

	private void initBluetooth() {

		mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
		if (mBluetoothAdapter == null) {

			Toast.makeText(mContext, mContext.getResources().getString(R.string.no_bt), Toast.LENGTH_SHORT).show();
			mBtnOpen.setEnabled(false);
			mBtnSearch.setEnabled(false);
			mBtnDisconn.setEnabled(false);

		}

	}

	public ConnectThread getConnect() {
		if (connectThread != null) {

			return connectThread;

		}
		return null;
	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.btn_disconn:
			if (clientSocket != null && clientSocket.isConnected()) {
				try {
					acceptThread.cancel();
					clientSocket.close();
					mTvCurrentState.setText(mContext.getResources().getString(R.string.close_con));
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			address = "";
			break;
		case R.id.btn_search:

			// 正在搜索则取消，以便重新开始搜索
			if (mBluetoothAdapter.isDiscovering()) {
				mBluetoothAdapter.cancelDiscovery();
			}

			mDataList.clear();
			mAdapter.notifyDataSetChanged();

			mBluetoothAdapter.startDiscovery();

			break;
		case R.id.btn_open:
			// 打开时点击关闭，关闭时点击打开
			if (mBluetoothAdapter.isEnabled()) {
				// 关闭操作
				/*
				 * 如果线程已经存在且正在阻塞，取消线程
				 */
				if (clientSocket != null && clientSocket.isConnected()) {

					try {
						clientSocket.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				mBluetoothAdapter.disable();

			} else {

				// 打开操作
				mBluetoothAdapter.enable();

			}
			break;
		default:
			break;
		}
	}

	@Override
	public void onDestroy() {

		mContext.unregisterReceiver(mReceiver);
		// Toast.makeText(mContext, "destory", Toast.LENGTH_LONG).show();

		// if (null != clientSocket && clientSocket.isConnected()) {
		//
		// connectThread.cancel();
		// }
		if (null != acceptThread && acceptThread.isAlive()) {
			acceptThread.cancel();
		}
		super.onDestroy();

	}

	/**
	 * 建立连接线程类
	 *
	 * @author user
	 */
	class ConnectThread extends Thread {
		BluetoothDevice device;
		OutputStream os = null;
		WriteCallBack writeCallBack = (FragmentSetting) ((MainActivity) mContext).getFragment(1);
		SettingCallBack settingCallBack;
		public BluetoothSocket Socket;

		public ConnectThread(BluetoothDevice device) {
			this.device = device;

			try {
				// 获取 BluetoothSocket
				clientSocket = device.createRfcommSocketToServiceRecord(D400Helper.uuid);
				this.Socket = clientSocket;
			} catch (IOException e1) {
				e1.printStackTrace();
			}

		}

		@Override
		public void run() {
			// 先取消继续搜索，以便建立链接
			if (mBluetoothAdapter.isDiscovering()) {
				mBluetoothAdapter.cancelDiscovery();
			}

			try {
				clientSocket.connect();
				mHandler.sendEmptyMessage(D400Helper.CONNECTSUCCESS);

			} catch (IOException e) {

				mHandler.sendEmptyMessage(D400Helper.CONNECTFAIL);
				try {
					clientSocket.close();
				} catch (IOException e1) {
					e1.printStackTrace();
				}

			}

			/*
			 * 连接上关闭设备通道，保持单链接
			 *
			 * if (clientSocket != null) { try { clientSocket.close(); } catch
			 * (IOException e) { e.printStackTrace(); } }
			 */

		}

		public void writeData(byte[] bytes) {
			try {
				os = clientSocket.getOutputStream();
				os.write(bytes);
				os.flush();
			} catch (IOException e) {
				e.printStackTrace();
			}

		}

		public void writeData(byte[] bytes, WriteCallBack writeCallBack) {

			writeData(bytes);
			this.writeCallBack = writeCallBack;
		}

		public void settingData(byte[] bytes, SettingCallBack settingCallBack) {

			writeData(bytes);
			this.settingCallBack = settingCallBack;
		}

		/**
		 * 关闭连接
		 */
		public void cancel() {

			try {
				clientSocket.close();
			} catch (IOException e) {
				e.printStackTrace();
			}

		}

	}

	interface WriteCallBack {
		void callback(int i);

		void callback(int i, Object obj);
	}

	interface SettingCallBack {
		void callback(int i);
	}

	/**
	 * Adapter
	 */
	class D400ListViewAdapter extends BaseAdapter {

		public D400ListViewAdapter() {
			int sum = 0;
			for (int i = 0; i < mDataList.size(); i++) {
				if (mDataList.get(i).getBondState() == BluetoothDevice.BOND_BONDED) {
					sum++;
				}
			}
			int size = mDataList.size();

			for (int i = 0; i < size; i++) {
				if (mDataList.get(i).getBondState() != BluetoothDevice.BOND_BONDED) {
					BluetoothDevice va = mDataList.get(i);
					mDataList.remove(i);
					mDataList.add(size - 1, va);
					i = i - 1;
				}
				if (sum - 1 == i) {
					break;
				}
			}
		}

		@Override
		public void notifyDataSetChanged() {
			int sum = 0;
			for (int i = 0; i < mDataList.size(); i++) {
				if (mDataList.get(i).getBondState() == BluetoothDevice.BOND_BONDED) {
					sum++;
				}
			}
			int size = mDataList.size();

			for (int i = 0; i < size; i++) {
				if (mDataList.get(i).getBondState() != BluetoothDevice.BOND_BONDED) {
					BluetoothDevice va = mDataList.get(i);
					mDataList.remove(i);
					mDataList.add(size - 1, va);
					i = i - 1;
				}
				if (sum - 1 == i) {
					break;
				}
			}
			super.notifyDataSetChanged();
		}

		@Override
		public int getCount() {
			return mDataList.size();
		}

		@Override
		public Object getItem(int position) {
			return mDataList.get(position);
		}

		@Override
		public long getItemId(int position) {
			return position;
		}

		@Override
		public View getView(final int position, View convertView, ViewGroup parent) {
			if (convertView == null) {

				convertView = LayoutInflater.from(mContext).inflate(R.layout.item_layout, null);

			}

			TextView textView = (TextView) convertView.findViewById(R.id.txt_device);
			ImageView imageView = (ImageView) convertView.findViewById(R.id.img_doit);
			textView.setText(mDataList.get(position).getName() + " \n" + mDataList.get(position).getAddress());

			imageView.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) {

					if (mDataList.get(position).getBondState() == BluetoothDevice.BOND_BONDED) {
						try {
							// 解绑
							Method removeBondMethod = BluetoothDevice.class.getMethod("removeBond");
							removeBondMethod.invoke(mDataList.get(position));
						} catch (IllegalArgumentException e) {
							e.printStackTrace();
						} catch (IllegalAccessException e) {
							e.printStackTrace();
						} catch (NoSuchMethodException e) {
							e.printStackTrace();
						} catch (InvocationTargetException e) {
							e.printStackTrace();
						}
					}

				}
			});

			if (mDataList.get(position).getBondState() == BluetoothDevice.BOND_BONDED) {

				imageView.setImageResource(R.drawable.boned);

			} else {
				imageView.setImageResource(R.drawable.waiting);
			}

			return convertView;
		}
	}

}
