package com.seuic.d400.d400settingdemo;

import android.app.Fragment;
import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;

/**
 * A simple {@link Fragment} subclass.
 */

public class FragmentSetting extends Fragment
		implements View.OnClickListener, CompoundButton.OnCheckedChangeListener, FragmentScanner.WriteCallBack {
	private View currentView;

	private Button mBtnGetVision;
	private Button mBtnReqPower;
	private Button mBtnPrefix;
	private Button mBtnSuffix;

	private Switch mSwVibrate;
	private boolean vibrateFlag;
	private Switch mSwPlaysound;
	private boolean soundFlag;

	private EditText mEdtPrefix;
	private EditText mEdtSuffix;

	private TextView mTxtSNvalue;

	private TextView mTxtPre;
	private TextView mTxtSuf;

	private Context mContext;

	private FragmentScanner mFragmentScanner;
	private FragmentScanner.ConnectThread connectThread;

	private Button mBtnSNw;
	private EditText mEdtSNw;

	private Button mBtnSN;

	private String mSN;

	public FragmentSetting() {

	}

	public void setmContext(Context mContext) {
		this.mContext = mContext;
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		currentView = inflater.inflate(R.layout.fragment_setting_layout, null);

		refresh();
		initView();
		return currentView;
	}

	public void refresh() {
		mFragmentScanner = (FragmentScanner) ((MainActivity) mContext).getFragment(0);
		connectThread = mFragmentScanner.getConnect();
		if (null == connectThread || null == connectThread.Socket || !connectThread.Socket.isConnected()) {
			// TODO 刷新UI状态
		}

	}

	private void initView() {
		mBtnGetVision = (Button) currentView.findViewById(R.id.btn_getvision);
		mBtnReqPower = (Button) currentView.findViewById(R.id.btn_reqpower);
		mBtnSuffix = (Button) currentView.findViewById(R.id.btn_suffix);
		mBtnPrefix = (Button) currentView.findViewById(R.id.btn_prefix);
		mBtnSN = (Button) currentView.findViewById(R.id.btn_sn);
		mBtnSNw = (Button) currentView.findViewById(R.id.btn_snw);

		mTxtSNvalue = (TextView) currentView.findViewById(R.id.txt_snvalue);
		mTxtPre = (TextView) currentView.findViewById(R.id.txt_prefix);
		mTxtSuf = (TextView) currentView.findViewById(R.id.txt_suffix);

		mEdtPrefix = (EditText) currentView.findViewById(R.id.edit_prefix);
		mEdtSuffix = (EditText) currentView.findViewById(R.id.edit_suffix);

		mEdtSNw = (EditText) currentView.findViewById(R.id.edit_snw);

		mEdtPrefix.setEnabled(false);
		mEdtSuffix.setEnabled(false);
		mEdtSNw.setEnabled(false);

		mSwPlaysound = (Switch) currentView.findViewById(R.id.swt_playsound);
		mSwVibrate = (Switch) currentView.findViewById(R.id.swt_vibrate);

		mBtnGetVision.setOnClickListener(this);
		mBtnReqPower.setOnClickListener(this);
		mBtnSuffix.setOnClickListener(this);
		mBtnPrefix.setOnClickListener(this);
		mBtnSN.setOnClickListener(this);
		mBtnSNw.setOnClickListener(this);

		mSwPlaysound.setOnCheckedChangeListener(this);
		mSwVibrate.setOnCheckedChangeListener(this);

	}

	public void initData() {

	}

	@Override
	public void onClick(View v) {
		if (null == connectThread || null == connectThread.Socket || !connectThread.Socket.isConnected()) {
			Toast.makeText(mContext, mContext.getResources().getString(R.string.con_dev), Toast.LENGTH_SHORT).show();
			return;
		}
		switch (v.getId()) {
		case R.id.btn_getvision:
			connectThread.writeData(CRCVerify.ReqToBytes("00".toString(), "00"));
			break;
		case R.id.btn_reqpower:
			connectThread.writeData(CRCVerify.ReqToBytes("04", "00"));
			break;
		case R.id.btn_sn:
			connectThread.writeData(CRCVerify.ReqToBytes("10", "00"));
			break;
		case R.id.btn_prefix:
			String str = (String) mBtnPrefix.getText();
			if (str.equals(mContext.getResources().getString(R.string.update))) {
				mEdtPrefix.setEnabled(true);
				mEdtPrefix.requestFocus();
				mBtnPrefix.setText(mContext.getResources().getString(R.string.save));
			} else if (str.equals(mContext.getResources().getString(R.string.save))) {
				if (mEdtPrefix.getText() == null || mEdtPrefix.getText().toString().trim().equals("")) {
					Toast.makeText(mContext, mContext.getResources().getString(R.string.pl_input), Toast.LENGTH_SHORT)
							.show();
					return;
				}
				connectThread.writeData(CRCVerify.ReqToBytes("08", mEdtPrefix.getText().toString()), this);
				mEdtPrefix.setText("");
			}
			break;
		case R.id.btn_suffix:
			String str1 = (String) mBtnSuffix.getText();
			if (str1.equals(mContext.getResources().getString(R.string.update))) {
				mEdtSuffix.setEnabled(true);
				mEdtSuffix.requestFocus();
				mBtnSuffix.setText(mContext.getResources().getString(R.string.save));
			} else if (str1.equals(mContext.getResources().getString(R.string.save))) {
				if (mEdtSuffix.getText() == null || mEdtSuffix.getText().toString().trim().equals("")) {
					Toast.makeText(mContext, mContext.getResources().getString(R.string.pl_input), Toast.LENGTH_SHORT)
							.show();
					return;
				}
				connectThread.writeData(CRCVerify.ReqToBytes("06", mEdtSuffix.getText().toString()), this);
				mEdtSuffix.setText("");
			}
			break;
		case R.id.btn_snw:

			String str2 = (String) mBtnSNw.getText();
			if (str2.equals(mContext.getResources().getString(R.string.update))) {
				mEdtSNw.setEnabled(true);
				mEdtSNw.requestFocus();
				mBtnSNw.setText(mContext.getResources().getString(R.string.save));
			} else if (str2.equals(mContext.getResources().getString(R.string.save))) {
				if (mEdtSNw.getText() == null || mEdtSNw.getText().toString().trim().equals("")) {
					Toast.makeText(mContext, mContext.getResources().getString(R.string.pl_input), Toast.LENGTH_SHORT)
							.show();
					return;
				}

				connectThread.writeData(CRCVerify.ReqToBytes("0E", mEdtSNw.getText().toString()), this);

			}
			break;

		default:
			break;

		}
	}

	@Override
	public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
		if (null == connectThread || null == connectThread.Socket || !connectThread.Socket.isConnected()) {
			Toast.makeText(mContext, mContext.getResources().getString(R.string.con_dev), Toast.LENGTH_SHORT).show();
			buttonView.setChecked(!isChecked);
			return;
		}
		switch (buttonView.getId()) {
		case R.id.swt_playsound:

			if (isChecked) {
				connectThread.writeData(CRCVerify.ReqToBytes("0A", "1"), this);
			} else {
				connectThread.writeData(CRCVerify.ReqToBytes("0A", "0"), this);
			}

			break;
		case R.id.swt_vibrate:
			if (isChecked) {
				connectThread.writeData(CRCVerify.ReqToBytes("0C", "1"), this);
			} else {
				connectThread.writeData(CRCVerify.ReqToBytes("0C", "0"), this);
			}
			break;
		default:
			break;

		}
	}

	@Override
	public void callback(int i) {
		switch (i) {
		case D400Helper.PREFIXSECCESS:
			mEdtPrefix.setEnabled(false);
			mBtnPrefix.setText(mContext.getResources().getString(R.string.update));
			break;
		case D400Helper.PREFIXFAIL:
			Toast.makeText(mContext, mContext.getResources().getString(R.string.pre_fix_fail), Toast.LENGTH_SHORT)
					.show();
			break;
		case D400Helper.SUFFIXSECCESS:
			mEdtSuffix.setEnabled(false);
			mBtnSuffix.setText(mContext.getResources().getString(R.string.update));
			break;
		case D400Helper.SUFFIXFAIL:
			Toast.makeText(mContext, mContext.getResources().getString(R.string.suf_fix_fail), Toast.LENGTH_SHORT)
					.show();
			break;
		case D400Helper.SOUNDSECCESS:
			Toast.makeText(mContext, mContext.getResources().getString(R.string.vol_fix_suc), Toast.LENGTH_SHORT)
					.show();
			break;
		case D400Helper.SOUNDFAIL:
			Toast.makeText(mContext, mContext.getResources().getString(R.string.vol_fix_fail), Toast.LENGTH_SHORT)
					.show();
			mSwPlaysound.setChecked(!mSwPlaysound.isChecked());
			break;
		case D400Helper.VIBRATESECCESS:
			Toast.makeText(mContext, mContext.getResources().getString(R.string.vib_fix_suc), Toast.LENGTH_SHORT)
					.show();
			break;
		case D400Helper.VIBRATEFAIL:
			Toast.makeText(mContext, mContext.getResources().getString(R.string.vib_fix_fail), Toast.LENGTH_SHORT)
					.show();
			mSwPlaysound.setChecked(!mSwVibrate.isChecked());
			break;
		case D400Helper.SNSECCESS:
			Toast.makeText(mContext, mContext.getResources().getString(R.string.SN_update_suc), Toast.LENGTH_SHORT)
					.show();

			break;
		case D400Helper.SNFAIL:
			Toast.makeText(mContext, mContext.getResources().getString(R.string.SN_update_fail), Toast.LENGTH_SHORT)
					.show();
			break;

		default:
			break;
		}
	}

	@Override
	public void callback(int i, Object obj) {
		switch (i) {
		case D400Helper.READSNSECCESS:
			mTxtSNvalue.setText(obj.toString());
			mEdtSNw.setEnabled(false);
			mBtnSNw.setText(mContext.getResources().getString(R.string.update));
			break;
		default:
			break;
		}
	}
}
