package com.seuic.d400.d400settingdemo;

import android.app.ActivityManager;
import android.content.Context;
import android.content.Intent;
import android.util.SparseIntArray;

import java.util.List;

/**
 * Created by user on 2015.11.02.
 */
public abstract class Scanner implements IScanner{



    public static final String ACTION_SEND_BARCODE = "com.android.server.scannerservice.broadcast";
    public static final String ACTION_SEND_KEY = "scannerdata";
    public static final String ACTION_SEND_KEY_CODE_TYPE = "codetype";
    private static final String ACTION_SCANNER_SERVICE_TERMINATE = "com.android.scanner.TERMINATE";
    private static final String SERVICE_NAME = "com.seuic.scanner.service.ScanService";
    private final static String ACTION_START_SCAN_SERVICE = "com.seuic.action.START_SCANSERVICE";

    protected boolean isEnabled = true;
    public abstract SparseIntArray getAllParams();
    protected static SparseIntArray paramArray = new SparseIntArray();

    Context mContext;

    Scanner(Context context){
        mContext = context;
    }

    public static void stopScanService(Context context){

        while(isRunning(context, SERVICE_NAME)){
            context.sendBroadcast(new Intent(ACTION_SCANNER_SERVICE_TERMINATE));
        }
        try {
            Thread.sleep(150);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    public static void startScanService(Context context){
        context.sendBroadcast(new Intent(ACTION_START_SCAN_SERVICE));
    }

    private static boolean isRunning(Context context ,String serviceName){
        ActivityManager am = (ActivityManager) context.getSystemService(Context.ACTIVITY_SERVICE);
        List<ActivityManager.RunningServiceInfo> infos = am.getRunningServices(100);
        for(ActivityManager.RunningServiceInfo serviceInfo : infos){
            if(serviceInfo.service.getClassName().equals(serviceName)){
                return true;
            }
        }
        return false;
    }

    @Override
    public void enable() {
        isEnabled = true;
    }

    @Override
    public void disable() {
        isEnabled = false;
    }


}
