package com.seuic.d400.d400settingdemo;

import android.content.Context;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.util.SparseIntArray;
import android.widget.Toast;

/**
 * Created by user on 2015.11.02.
 */
public class Scanner1D extends Scanner{




    private final static String LOG_TAG = "Scanner1D";



    private static DecodeCallback callback;

    private static DecodeInfoCallBack infoCallBack;

    private Thread mThread;

    public boolean isOpened = false;

    protected int laser_time;

    public FragmentScanner.ConnectThread connectThread;

    static {
//        System.loadLibrary("Scanner1D");

        paramArray.put(ParamCode.LASTER_ONTIME,					0x1);
        paramArray.put(ParamCode.TIMEOUT_SAMESYMBOL,			0x3);
        paramArray.put(ParamCode.SECURITY_LEVEL,				0x4);
        paramArray.put(ParamCode.BIDIRECTIONAL, 				0x5);

        paramArray.put(ParamCode.UPCA, 							0x91);
        paramArray.put(ParamCode.UPCE, 							0x92);
        paramArray.put(ParamCode.UPCE1, 						0x93);
        paramArray.put(ParamCode.EAN8, 							0x94);
        paramArray.put(ParamCode.EAN13, 						0x95);
        paramArray.put(ParamCode.BOOKLAND, 						0x96);
        paramArray.put(ParamCode.UPCA_CHK, 						0x97);
        paramArray.put(ParamCode.UPCE_CHK, 						0x98);
        paramArray.put(ParamCode.UPCE1_CHK, 					0x99);
        paramArray.put(ParamCode.UPCA_PREAM, 					0x9a);
        paramArray.put(ParamCode.UPCE_PREAM, 					0x9b);
        paramArray.put(ParamCode.UPCE1_PREAM, 					0x9c);
        paramArray.put(ParamCode.UPCE_TO_A, 					0x9d);
        paramArray.put(ParamCode.UPCE1_TO_A, 					0x9e);
        paramArray.put(ParamCode.COUPON, 						0x9f);

        paramArray.put(ParamCode.CODE128, 						0x111);
        paramArray.put(ParamCode.ISBT128, 						0x113);
        paramArray.put(ParamCode.GS1128, 						0x112);
//        paramArray.put(ParamCode.ISBT128_PREDEFINED,			0x114);

        paramArray.put(ParamCode.CODE39, 						0x121);
        paramArray.put(ParamCode.TRIC39, 						0x122);
        paramArray.put(ParamCode.CODE39_FULL_ASCII, 			0x123);
        paramArray.put(ParamCode.CODE39_TO_CODE32, 				0x124);
        paramArray.put(ParamCode.CODE32_PREFIX, 				0x125);
        paramArray.put(ParamCode.CODE39_LEN_MIN, 				0x126);
        paramArray.put(ParamCode.CODE39_LEN_MAX, 				0x127);
        paramArray.put(ParamCode.CODE39_CHK, 					0x128);
        paramArray.put(ParamCode.CODE39_VER, 					0x129);

        paramArray.put(ParamCode.CODE93, 						0x131);
        paramArray.put(ParamCode.CODE93_LEN_MIN, 				0x132);
        paramArray.put(ParamCode.CODE93_LEN_MAX, 				0x133);

        paramArray.put(ParamCode.CODE11, 						0x141);
        paramArray.put(ParamCode.CODE11_LEN_MIN, 				0x142);
        paramArray.put(ParamCode.CODE11_LEN_MAX, 				0x143);
        paramArray.put(ParamCode.CODE11_CHK_VER, 				0x144);
        paramArray.put(ParamCode.CODE11_CHK, 					0x145);

        paramArray.put(ParamCode.I25, 							0x151);
        paramArray.put(ParamCode.I25_LEN_MIN, 					0x152);
        paramArray.put(ParamCode.I25_LEN_MAX, 					0x153);

        paramArray.put(ParamCode.MSI, 							0x161);
        paramArray.put(ParamCode.MSI_LEN_MIN, 					0x162);
        paramArray.put(ParamCode.MSI_LEN_MAX, 					0x163);

        paramArray.put(ParamCode.CODEBAR, 						0x171);
        paramArray.put(ParamCode.CODEBAR_LEN_MIN, 				0x172);
        paramArray.put(ParamCode.CODEBAR_LEN_MAX, 				0x173);

        paramArray.put(ParamCode.D25, 							0x181);
        paramArray.put(ParamCode.D25_LEN_MIN, 					0x182);
        paramArray.put(ParamCode.D25_LEN_MAX, 					0x183);

        paramArray.put(ParamCode.C25, 							0x191);
        paramArray.put(ParamCode.C25_LEN_MIN, 					0x192);
        paramArray.put(ParamCode.C25_LEN_MAX, 					0x193);
    }

    public SparseIntArray getAllParams() {
        return paramArray;
    }

    private Runnable runnable = new Runnable() {

        @Override
        public void run() {
            while (true) {
                synchronized (runnable) {
                    try {
                        runnable.wait();
                    } catch (InterruptedException e) {
                        Log.i(LOG_TAG, "Error:" + e.getMessage());
                    }
                    decode();
                }
            }
        }
    };

    private Handler mHandler = new DecodeHandler();

    Scanner1D(Context context) {
        super(context);

    }

    public boolean open() {
        Log.i(LOG_TAG, "start to open !!");
        if(isOpened){
            return true;
        }
/*
        if (JNIOpen()) {
            isOpened = true;
            laser_time = getLaserTime();
            mThread = new Thread(runnable);
            mThread.start();
            Log.i(LOG_TAG, "open done !!");
            return true;
        }*/
        return false;
    }

    public void close() {
//        JNIClose();
        isOpened = false;
    }

    @Override
    public void startScan() {
        scan();
    }

    void scan() {
        if(!scanFinished){
            return ;
        }

        synchronized (runnable) {
            runnable.notify();
        }
    }


    static Boolean scanFinished = true;
    private void decode() {
        synchronized (this) {
            scanFinished = false;
            BarcodeInfo barcodeInfo = new BarcodeInfo();
            //根据出光时间设置扫描超时时间
            if(isEnabled){
//                if (JNIGetBarcode(barcodeInfo, laser_time)) {
//                    //扫描灯闪烁
//                    ScanLed.setLed(1);
//                    Message msg = mHandler.obtainMessage();
//                    msg.obj = barcodeInfo;
//                    mHandler.sendMessage(msg);
//                }
            }
            scanFinished = true;
        }
    }

    @Override
    public void stopScan() {
//        JNIStopScan();
    }

    @Override
    public void enable() {
        super.enable();
//        JNIEnableScan();
    }

    @Override
    public void disable() {
        super.disable();
//        JNIDisableScan();
    }

    @Override
    public boolean setParams(int id, int value,FragmentScanner.ConnectThread connectThread,FragmentScanner.SettingCallBack callback) {

        this.connectThread = connectThread;
        if(paramArray.get(id , -1) == -1 && id != ParamCode.FACTORY_DEFAULT){
            return false;
        }

        boolean ret = false;

        if (id == ParamCode.FACTORY_DEFAULT) {
            //TODO
//            ret = JNIFactoryDefault();
            if(ret){
                try {
                    //Add buff time
                    Thread.sleep(500);
                    laser_time = getLaserTime();
                } catch (Exception e) {

                }
            }
            return ret;
        }

        ScanParam param = new ScanParam();
        param.id = paramArray.get(id);
        param.value = value;
        //TODO 设置指环
        if (null == connectThread || null == connectThread.Socket || !connectThread.Socket.isConnected()) {
            Toast.makeText(mContext, "请等待蓝牙设备连接和建立通道！", Toast.LENGTH_SHORT).show();
            return false;
        }
        String hexID = Integer.toHexString(param.id);
        String hexValue = Integer.toHexString(param.value);

        String[] strs = new String[]{hexID,hexValue};

        connectThread.settingData(CRCVerify.ReqToBytes("1A",strs), callback);
//        ret = JNISetParam(param);
//        if(ret && id == ParamCode.LASTER_ONTIME){
//            setLaserTime(value);
//        }
//        return ret;
        return true;
    }


    @Override
    public int getParams(int id) {

        if(paramArray.get(id ,-1) == -1){
            return 0;
        }

        ScanParam param = new ScanParam();
        param.id = paramArray.get(id);
//        boolean ret = JNIGetParam(param);

//        if (ret) {
//            return param.value;
//        }
        return param.value;
    }

    private class BarcodeInfo {
        public String data;
        public int length;
        public String type;
    }

//    @Override
//    public void setDecodeCallBack(DecodeCallback decodeCallback) {
//        callback = decodeCallback;
//    }

    static class DecodeHandler extends Handler {
        public void handleMessage(Message msg) {
            BarcodeInfo barcodeInfo = (BarcodeInfo) msg.obj;
            if (callback != null && !"".equals(barcodeInfo.data)) {
                callback.onDecodeComplete(barcodeInfo.data);
            }

            if(infoCallBack != null && !"".equals(barcodeInfo.data)){
                DecodeInfo info = new DecodeInfo();
                info.barcode = barcodeInfo.data;
                info.codetype = barcodeInfo.type;
                info.length = barcodeInfo.length;
                infoCallBack.onDecodeComplete(info);
            }
        };
    }

//
//    @Override
//    public void setDecodeInfoCallBack(DecodeInfoCallBack callback) {
//        infoCallBack = callback;
//    }

    protected int getLaserTime(){
        return -1;
    }

    protected void setLaserTime(int time){
        laser_time = time;
    }


}
