package com.seuic.d400.d400settingdemo;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import com.seuic.d400.d400settingdemo.IScanner.ParamCode;
import com.seuic.d400.d400settingdemo.ParamObject.ViewType;

import android.annotation.SuppressLint;
import android.app.ActionBar;
import android.app.AlertDialog;
import android.app.Fragment;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.res.Resources;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.Html;
import android.text.Spanned;
import android.util.Log;
import android.util.SparseArray;
import android.util.SparseIntArray;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.BaseExpandableListAdapter;
import android.widget.EditText;
import android.widget.ExpandableListView;
import android.widget.TextView;
import android.widget.Toast;

@SuppressLint("NewApi")
public class FragmentOtherSetting extends Fragment {
	private View currentView;

	private FragmentScanner.ConnectThread connectThread;

	private FragmentScanner mFragmentScanner;
	/**
	 * 二级选项
	 */
	private Map<Integer, ParamObject> mBindMap = new LinkedHashMap<Integer, ParamObject>();
	/**
	 *
	 */
	private Map<String, SparseArray<String>> groupMap = new LinkedHashMap<String, SparseArray<String>>();

	/**
	 * 1级选项
	 */
	private Object[] group;
	private Context mContext;

	private ExpandableListView mExpList;
	private ExpandAdapter mAdapter;

	private static ParamObject childObject;

	private static String[] switchString = null;

	private static EditText inputText;

	private ClickListener clickListener;

	Resources resources;

	ProgressDialog dialog;

	private final static String LOG_TAG = "FragmentOtherSetting";

	private SE955Scanner scanner;

	public FragmentOtherSetting() {
	}

	public void setmContext(Context mContext) {
		this.mContext = mContext;
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		currentView = inflater.inflate(R.layout.fragment_othersettting_layout, null);
		resources = mContext.getResources();
		scanner = new SE955Scanner(mContext);
		switchString = resources.getStringArray(R.array.bfswitchString);
		clickListener = new ClickListener();
		initView();
		refresh();
		refreshConnect();
		return currentView;
	}

	private void initView() {

		mExpList = (ExpandableListView) currentView.findViewById(R.id.explst_settings);
	}

	public void refreshConnect() {
		mFragmentScanner = (FragmentScanner) ((MainActivity) mContext).getFragment(0);
		connectThread = mFragmentScanner.getConnect();
		if (null == connectThread || null == connectThread.Socket || !connectThread.Socket.isConnected()) {
			Toast.makeText(mContext, mContext.getResources().getString(R.string.bt_not_connect), Toast.LENGTH_SHORT)
					.show();
		}

	}

	Handler handler = new Handler() {
		public void handleMessage(android.os.Message msg) {

			mAdapter = new ExpandAdapter();

			mExpList.setAdapter(mAdapter);
			mExpList.setOnChildClickListener(new ChildClickListener());
			// dialog.dismiss();
		}

		;
	};

	void loadParams() {
		/*
		 * dialog = ProgressDialog.show(mContext, null,
		 * resources.getString(R.string.bfDataUploading), true, false);
		 * dialog.setCanceledOnTouchOutside(false);
		 */
		new Thread() {
			@Override
			public void run() {

				bindParams();
				// bindItem();
				handler.sendMessage(Message.obtain());
			}
		}.start();
	}

	private List<String> groupList = new ArrayList<String>();

	private void bindParams() {
		synchronized (groupMap) {

			groupMap.clear();
			mBindMap.clear();
			groupList.clear();

			if (groupMap.size() == 0) {
				Log.v(LOG_TAG, "groupMap clear");
			}
			// if(groupMap.size() > 0){
			// return;
			// }

			// ID��������

			// Code 128 --------------
			SparseArray<String> tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.LASTER_ONTIME, resources.getString(R.string.bfDuration));
			tempMap.put(ParamCode.SCAN_ANGLE, resources.getString(R.string.bfScanningAngle));
			tempMap.put(ParamCode.TIMEOUT_SAMESYMBOL, resources.getString(R.string.bfTimeout));
			tempMap.put(ParamCode.SECURITY_LEVEL, resources.getString(R.string.bfSecurityLevel));
			tempMap.put(ParamCode.BIDIRECTIONAL, resources.getString(R.string.bfBilateralScanning));
			tempMap.put(ParamCode.LIGHTS, resources.getString(R.string.bfLighting));
			tempMap.put(ParamCode.LCD_DISPLAY, resources.getString(R.string.bfLcdmode));
			tempMap.put(ParamCode.DECODETIMEOUT, resources.getString(R.string.bfDecodeTimeout));
			tempMap.put(ParamCode.ILLUMINATION_LEVEL, resources.getString(R.string.bfIllumPowerLevel));
			groupBind(resources.getString(R.string.bfBasicSettings), tempMap);

			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.CODE128, resources.getString(R.string.bfCode128Name));
			tempMap.put(ParamCode.CODE128_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.CODE128_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			tempMap.put(ParamCode.GS1128, resources.getString(R.string.bfGS1128Name));
			tempMap.put(ParamCode.ISBT128, resources.getString(R.string.bfISBT128Name));
			tempMap.put(ParamCode.ISBT128_PREDEFINED, resources.getString(R.string.bfISBT128Predifined));
			groupBind(resources.getString(R.string.bfCode128Name), tempMap);

			// UPC/EAN --------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.UPCA, resources.getString(R.string.bfUPCAName));
			tempMap.put(ParamCode.UPCE, resources.getString(R.string.bfUPCEName));
			tempMap.put(ParamCode.UPCE1, resources.getString(R.string.bfUPCE1Name));
			tempMap.put(ParamCode.EAN8, resources.getString(R.string.bfEAN8Name));
			tempMap.put(ParamCode.EAN13, resources.getString(R.string.bfEAN13Name));
			tempMap.put(ParamCode.BOOKLAND, resources.getString(R.string.bfBooklandEANName));
			tempMap.put(ParamCode.UPCA_CHK, resources.getString(R.string.bfTransmissionUPCAAuthenticationCodes));
			tempMap.put(ParamCode.UPCE_CHK, resources.getString(R.string.bfTransmissionUPCEAuthenticationCodes));
			tempMap.put(ParamCode.UPCE1_CHK, resources.getString(R.string.bfTransmissionUPCE1AuthenticationCodes));
			tempMap.put(ParamCode.UPCA_PREAM, resources.getString(R.string.bfUPCAPrefix));
			tempMap.put(ParamCode.UPCE_PREAM, resources.getString(R.string.bfUPCEPrefix));
			tempMap.put(ParamCode.UPCE1_PREAM, resources.getString(R.string.bfUPCE1Prefix));
			tempMap.put(ParamCode.UPCE_TO_A, resources.getString(R.string.bfUPCEtoUPCA));
			tempMap.put(ParamCode.UPCE1_TO_A, resources.getString(R.string.bfUPCE1toUPCA));
			tempMap.put(ParamCode.EAN8_TO_13, resources.getString(R.string.bfEAN8toEAN13));
			tempMap.put(ParamCode.UPCE_EXPANDED, resources.getString(R.string.bfupceexpanded));
			tempMap.put(ParamCode.COUPON, resources.getString(R.string.bfUCCCouponExtendedCodeModel));
			groupBind(resources.getString(R.string.bfUPCEAN), tempMap);

			// Code 39 --------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.CODE39, resources.getString(R.string.bfCode39Name));
			tempMap.put(ParamCode.TRIC39, resources.getString(R.string.bfTriopticCode39Name));
			tempMap.put(ParamCode.CODE39_FULL_ASCII, resources.getString(R.string.bfCode39FULLASCII));
			tempMap.put(ParamCode.CODE39_TO_CODE32, resources.getString(R.string.bfCode39toCode32));
			tempMap.put(ParamCode.CODE32_PREFIX, resources.getString(R.string.bfCode32AddA));
			tempMap.put(ParamCode.CODE39_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.CODE39_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			tempMap.put(ParamCode.CODE39_CHK, resources.getString(R.string.bfTransmissionCodes));
			tempMap.put(ParamCode.CODE39_VER, resources.getString(R.string.bfTheInspectionCheckCode));
			groupBind(resources.getString(R.string.bfCode39Name), tempMap);

			// Code 93 --------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.CODE93, resources.getString(R.string.bfCode93Name));
			tempMap.put(ParamCode.CODE93_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.CODE93_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind(resources.getString(R.string.bfCode93Name), tempMap);

			// Code 11 --------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.CODE11, resources.getString(R.string.bfCode11Name));
			tempMap.put(ParamCode.CODE11_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.CODE11_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			tempMap.put(ParamCode.CODE11_CHK_VER, resources.getString(R.string.bfTheInspectionCheckCode));
			tempMap.put(ParamCode.CODE11_CHK, resources.getString(R.string.bfTransmissionCodes));
			groupBind(resources.getString(R.string.bfCode11Name), tempMap);

			// Interleaved 2 of 5 --------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.I25, resources.getString(R.string.bfInterleave2of5Name));
			tempMap.put(ParamCode.I25_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.I25_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind(resources.getString(R.string.bfInterleave2of5Name), tempMap);

			// Discrete 2 of 5 --------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.D25, resources.getString(R.string.bfDiscrete2of5Name));
			tempMap.put(ParamCode.D25_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.D25_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind(resources.getString(R.string.bfDiscrete2of5Name), tempMap);

			// Chinese 2 of 5 -----------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.C25, resources.getString(R.string.bfChinese2of5Name));
			groupBind(resources.getString(R.string.bfChinese2of5Name), tempMap);

			// Codebar ------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.CODEBAR, resources.getString(R.string.bfCodabarName));
			tempMap.put(ParamCode.CODEBAR_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.CODEBAR_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind("Codebar", tempMap);

			// MSI ----------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.MSI, resources.getString(R.string.bfMSIName));
			tempMap.put(ParamCode.MSI_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.MSI_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind(resources.getString(R.string.bfMSIName), tempMap);

			// RSS ----------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.RSS14, resources.getString(R.string.bfRSS14Name));
			tempMap.put(ParamCode.RSS_EXPANDED, resources.getString(R.string.bfRSSExpanded));
			tempMap.put(ParamCode.RSS_LIMIT, resources.getString(R.string.bfRSSLimit));
			tempMap.put(ParamCode.RSS_TO_UPCEAN, resources.getString(R.string.bfRSSToUPCEAN));
			groupBind(resources.getString(R.string.bfRSSName), tempMap);

			// QR ------------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.QRCODE, resources.getString(R.string.bfQRCodeName));
			tempMap.put(ParamCode.QRCODE_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.QRCODE_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			tempMap.put(ParamCode.QRINVERSE, resources.getString(R.string.bfQRInverse));
			tempMap.put(ParamCode.MICROQR, resources.getString(R.string.bfMicroQRName));
			groupBind(resources.getString(R.string.bfQRName), tempMap);

			// Data Matrix ---------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.DM, resources.getString(R.string.bfDataMatrixName));
			tempMap.put(ParamCode.DM_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.DM_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			tempMap.put(ParamCode.DMINVERSE, resources.getString(R.string.bfDataMatrixInverse));
			tempMap.put(ParamCode.DMI, resources.getString(R.string.bfDecodeMirrorImages));
			groupBind(resources.getString(R.string.bfDataMatrixName), tempMap);

			// China Post -----------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.CHINAPOST, resources.getString(R.string.bfChinaPostName));
			tempMap.put(ParamCode.CHINAPOST_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.CHINAPOST_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind(resources.getString(R.string.bfChinaPostName), tempMap);

			// Matrix 2 of 5 --------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.M25, resources.getString(R.string.bfMatrix2of5));
			tempMap.put(ParamCode.M25_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.M25_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind(resources.getString(R.string.bfMatrix2of5), tempMap);

			// Postnet --------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.POSTNET, resources.getString(R.string.bfPostnetName));
			tempMap.put(ParamCode.POSTNET_CHK, resources.getString(R.string.bfPostnetChkCodeName));
			tempMap.put(ParamCode.PLANET, resources.getString(R.string.bfPlanetCodeName));
			tempMap.put(ParamCode.PLANET_CHK, resources.getString(R.string.bfPlanetChkCodeName));
			tempMap.put(ParamCode.BRITISHPOST, resources.getString(R.string.bfBritishPostName));
			tempMap.put(ParamCode.JAPPOST, resources.getString(R.string.bfJapanesePostName));
			tempMap.put(ParamCode.AUSPOST, resources.getString(R.string.bfAustralianPostName));
			tempMap.put(ParamCode.UPU_FICS_POSTAL, resources.getString(R.string.bfUPUFICSPostalName));
			tempMap.put(ParamCode.USPS_4CB, resources.getString(R.string.bfUSPS4CBName));
			tempMap.put(ParamCode.NETHERLANDS_KIX_CODE, resources.getString(R.string.bfNetherlandsKIXCode));
			groupBind(resources.getString(R.string.bfPostalCode), tempMap);

			// Korean 3 of 5 --------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.K35, resources.getString(R.string.bfKorean3of5Name));
			groupBind(resources.getString(R.string.bfKorean3of5Name), tempMap);

			// EAN UCC Composite ----------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.COMPOSITE, resources.getString(R.string.bfEANUCCCompositeName));
			tempMap.put(ParamCode.COMPOSITE_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.COMPOSITE_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind(resources.getString(R.string.bfEANUCCCompositeName), tempMap);

			// Composite ------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.COMPOSITE_CC_C, resources.getString(R.string.bfCompositeCCC));
			tempMap.put(ParamCode.COMPOSITE_CC_AB, resources.getString(R.string.bfCompositeCCAB));
			tempMap.put(ParamCode.COMPOSITE_TLC_39, resources.getString(R.string.bfCompositeTLC39));
			tempMap.put(ParamCode.COMPOSITE_UPCEAN, resources.getString(R.string.bfCompositeUPCEAN));
			groupBind(resources.getString(R.string.bfComposite), tempMap);

			// PDF417 ---------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.PDF417, resources.getString(R.string.bfPDF417Name));
			tempMap.put(ParamCode.PDF417_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.PDF417_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind(resources.getString(R.string.bfPDF417Name), tempMap);

			// MicroPDF417 ----------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.MICROPDF417, resources.getString(R.string.bfMicroPDF417Name));
			tempMap.put(ParamCode.MICROPDF417_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.MICROPDF417_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind(resources.getString(R.string.bfMicroPDF417Name), tempMap);

			// MaxiCode -------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.MAXICODE, resources.getString(R.string.bfMaxiCodeName));
			tempMap.put(ParamCode.MAXICODE_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.MAXICODE_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind(resources.getString(R.string.bfMaxiCodeName), tempMap);

			// Aztec ----------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.AZTECCODE, resources.getString(R.string.bfAztecName));
			tempMap.put(ParamCode.AZTECCODE_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.AZTECCODE_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			tempMap.put(ParamCode.AZTECCODE_INVERSE, resources.getString(R.string.bfAztecInverse));
			groupBind(resources.getString(R.string.bfAztecName), tempMap);

			// Codeblock F ----------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.CODEBLOCKF, resources.getString(R.string.bfCodeblockF));
			tempMap.put(ParamCode.CODEBLOCKF_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.CODEBLOCKF_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			groupBind(resources.getString(R.string.bfCodeblockF), tempMap);

			// Telepen --------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.TELEPEN, resources.getString(R.string.bfTelepenName));
			tempMap.put(ParamCode.TELEPEN_LEN_MIN, resources.getString(R.string.bfMinimumLength));
			tempMap.put(ParamCode.TELEPEN_LEN_MAX, resources.getString(R.string.bfMaximumLength));
			tempMap.put(ParamCode.TELEPEN_OLDSTYLE, resources.getString(R.string.bfTelepenOLDStyle));
			groupBind(resources.getString(R.string.bfTelepenName), tempMap);

			// OCR ------------------------------
			tempMap = new SparseArray<String>();
			tempMap.put(ParamCode.OCR, resources.getString(R.string.bfOCRName));
			tempMap.put(ParamCode.OCR_TEMPLATE, resources.getString(R.string.bfTemplateSelection));
			groupBind(resources.getString(R.string.bfOCRName), tempMap);

			group = groupList.toArray();
		}
	}

	private void groupBind(String groupName, SparseArray<String> array) {
		SparseIntArray mapParam = scanner.getAllParams();
		SparseArray<String> temp = new SparseArray<String>();
		for (int i = 0, size = array.size(); i < size; i++) {
			int key = array.keyAt(i);
			if (mapParam.get(key, -1) != -1) {
				temp.put(key, array.get(key));
				addItem(key, array);
			}
		}
		if (temp.size() > 0) {
			groupMap.put(groupName, temp);
			groupList.add(groupName);
		}
	}

	private void addItem(int key, SparseArray<String> array) {

		String description = null;
		ParamObject.ViewType type = null;
		String[] choices = null;
		int[] interval = null;
		int paramValue = 0;

		switch (key) {
		case ParamCode.CODE11:
		case ParamCode.CODE11_CHK:
		case ParamCode.CODE11_CHK_VER:
		case ParamCode.CODE11_LEN_MAX:
		case ParamCode.CODE11_LEN_MIN:
			paramValue = 0;
			break;
		}

		switch (key) {
		case ParamCode.ISBT128_PREDEFINED:
			type = ParamObject.ViewType.NUMERICTEXT;
			/*
			 * if (mScanner instanceof N4313Scanner) { interval = new int[] { 0,
			 * 2 }; }
			 */
			break;
		case ParamCode.ILLUMINATION_LEVEL:
			type = ParamObject.ViewType.NUMERICTEXT;
			/*
			 * if (scnManager.getScanner() instanceof SE4500Scanner) { interval
			 * = new int[] { 1, 10 }; }
			 */
			break;
		case ParamCode.DECODETIMEOUT:
			type = ParamObject.ViewType.NUMERICTEXT;
			/*
			 * if (scnManager.getScanner() instanceof SE4500Scanner) { interval
			 * = new int[] { 1, 99 }; }
			 */
			break;
		case ParamCode.CODE128_LEN_MAX:
		case ParamCode.CODE128_LEN_MIN:
			type = ViewType.NUMERICTEXT;
			/*
			 * if (scnManager.getScanner() instanceof HHPScanner) { interval =
			 * new int[] { 0, 80 }; } else {
			 */
			interval = new int[] { 0, 55 };
			// }
			break;
		case ParamCode.QRINVERSE:
		case ParamCode.DMINVERSE:
			type = ViewType.SINGLECHOICE;
			choices = resources.getStringArray(R.array.bfdmiInverse);
			;
			break;
		case ParamCode.DMI:
			type = ViewType.SINGLECHOICE;
			choices = resources.getStringArray(R.array.bfdmi);
			break;
		case ParamCode.UPCA_PREAM:
		case ParamCode.UPCE1_PREAM:
		case ParamCode.UPCE_PREAM:
			type = ViewType.SINGLECHOICE;
			// if (mScanner instanceof N4313Scanner) {
			// choices = resources.getStringArray(R.array.bfUPCEPreamN4300);
			// } else {
			choices = resources.getStringArray(R.array.bfUPCEPream);
			// }

			break;
		case ParamCode.LASTER_ONTIME:
			type = ViewType.NUMERICTEXT;
			// if (mScanner instanceof UE966Scanner) {
			// interval = new int[] { 0, 99 };
			// } else if (mScanner instanceof N4313Scanner) {
			// interval = new int[] { 1, 30000 };
			// } else {
			interval = new int[] { 0, 255 };
			// }
			break;
		case ParamCode.SCAN_ANGLE:
			type = ViewType.SINGLECHOICE;
			// if (mScanner instanceof N4313Scanner) {
			// choices = new String[] { "48", "35" };
			// interval = new int[] { 0, 1 };
			// } else {
			choices = new String[] { "37", "47" };
			interval = new int[] { 5, 6 };
			// }
			break;
		case ParamCode.TIMEOUT_SAMESYMBOL:
			type = ViewType.NUMERICTEXT;
			// if (mScanner instanceof N4313Scanner) {
			// interval = new int[] { 0, 30000 };
			// } else {
			interval = new int[] { 0, 99 };
			// }
			break;
		case ParamCode.SECURITY_LEVEL:
			type = ViewType.NUMERICTEXT;
			interval = new int[] { 1, 4 };
			break;
		case ParamCode.CODE11_LEN_MIN:
		case ParamCode.CODE11_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			// if (mScanner instanceof HHPScanner
			// || mScanner instanceof N4313Scanner) {
			// interval = new int[] { 1, 80 };
			// } else {
			interval = new int[] { 4, 55 };
			// }
			break;
		case ParamCode.CODE11_CHK:

			// if (mScanner instanceof N4313Scanner) {
			// type = ViewType.SINGLECHOICE;
			// choices = resources
			// .getStringArray(R.array.bfUPCETransmitCheckDigit);
			//
			// } else {
			type = ViewType.SWITCH;
			// }
			break;
		case ParamCode.CODE39_LEN_MIN:
		case ParamCode.CODE39_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			// if (mScanner instanceof HHPScanner) {
			// interval = new int[] { 0, 48 };
			// } else if (mScanner instanceof N4313Scanner) {
			// interval = new int[] { 1, 80 };
			// } else {
			interval = new int[] { 2, 55 };
			// }
			break;
		case ParamCode.CODE39_CHK:
			// if (mScanner instanceof N4313Scanner) {
			// type = ViewType.SINGLECHOICE;
			// choices = resources.getStringArray(R.array.bfCode39Chk);
			// interval = new int[] { 0, 2 };
			// } else {
			type = ViewType.SWITCH;
			// }
			break;
		case ParamCode.CODE93_LEN_MIN:
		case ParamCode.CODE93_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			// if (mScanner instanceof HHPScanner) {
			// interval = new int[] { 4, 80 };
			// } else if (mScanner instanceof SE4500Scanner) {
			// interval = new int[] { 4, 55 };
			// } else if (mScanner instanceof N4313Scanner) {
			// interval = new int[] { 1, 80 };
			// } else {
			interval = new int[] { 0, 55 };
			// }
			break;
		case ParamCode.CODEBAR_LEN_MIN:
		case ParamCode.CODEBAR_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			// if (mScanner instanceof HHPScanner) {
			// interval = new int[] { 2, 60 };
			// } else if (mScanner instanceof N4313Scanner) {
			// interval = new int[] { 1, 80 };
			// } else {
			interval = new int[] { 5, 55 };
			// }
			break;
		case ParamCode.D25_LEN_MIN:
		case ParamCode.D25_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			// if (mScanner instanceof N4313Scanner) {
			// interval = new int[] { 1, 80 };
			// } else {
			interval = new int[] { 0, 55 };
			// }
			break;
		case ParamCode.I25_LEN_MIN:
		case ParamCode.I25_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			// if (mScanner instanceof HHPScanner) {
			// interval = new int[] { 2, 80 };
			// } else if (mScanner instanceof N4313Scanner) {
			// interval = new int[] { 1, 80 };
			// } else {
			interval = new int[] { 0, 55 };
			// }
			break;
		case ParamCode.MSI_LEN_MIN:
		case ParamCode.MSI_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			// if (mScanner instanceof HHPScanner) {
			// interval = new int[] { 4, 48 };
			// } else if (mScanner instanceof N4313Scanner) {
			// interval = new int[] { 1, 80 };
			// } else {
			interval = new int[] { 4, 55 };
			// }
			break;
		case ParamCode.CHINAPOST_LEN_MIN:
		case ParamCode.CHINAPOST_LEN_MAX:
		case ParamCode.M25_LEN_MIN:
		case ParamCode.M25_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			// if (mScanner instanceof HHPScanner) {
			// interval = new int[] { 4, 80 };
			// } else if (mScanner instanceof N4313Scanner) {
			// interval = new int[] { 1, 80 };
			// } else {
			interval = new int[] { 0, 55 };
			// }
			break;
		case ParamCode.COMPOSITE_LEN_MIN:
		case ParamCode.COMPOSITE_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			interval = new int[] { 1, 300 };
			break;
		case ParamCode.PDF417_LEN_MIN:
		case ParamCode.PDF417_LEN_MAX:
		case ParamCode.MICROPDF417_LEN_MIN:
		case ParamCode.MICROPDF417_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			interval = new int[] { 1, 2750 };
			break;
		case ParamCode.DM_LEN_MIN:
		case ParamCode.DM_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			interval = new int[] { 1, 3166 };
			break;
		case ParamCode.MAXICODE_LEN_MIN:
		case ParamCode.MAXICODE_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			interval = new int[] { 1, 150 };
			break;
		case ParamCode.QRCODE_LEN_MIN:
		case ParamCode.QRCODE_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			interval = new int[] { 0, 7089 };
			break;
		case ParamCode.AZTECCODE_LEN_MIN:
		case ParamCode.AZTECCODE_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			interval = new int[] { 1, 3832 };
			break;
		case ParamCode.CODEBLOCKF_LEN_MIN:
		case ParamCode.CODEBLOCKF_LEN_MAX:
			type = ViewType.NUMERICTEXT;
			interval = new int[] { 0, 2048 };
			break;
		case ParamCode.TELEPEN_LEN_MAX:
		case ParamCode.TELEPEN_LEN_MIN:
			type = ViewType.NUMERICTEXT;
			interval = new int[] { 1, 60 };
			break;
		case ParamCode.OCR_TEMPLATE:
			type = ViewType.SINGLECHOICE;
			choices = new String[] { "User", "Passport", "ISBN", "Price Field", "MICR E-13B" };
			interval = new int[] { 0x01, 0x02, 0x04, 0x08, 0x10 };
			break;
		case ParamCode.LIGHTS:
			type = ViewType.SINGLECHOICE;
			choices = new String[] { "Only LED", "Only Aimer", "No Aimer AND LED", "Both Aimer AND LED" };
			interval = new int[] { 1, 2, 0, 3 };
			break;
		default:
			type = ViewType.SWITCH;
			break;
		}

		paramValue = scanner.getParams(key);
		description = array.get(key);
		if (interval != null && choices == null) {
			description = description + "(" + interval[0] + "~" + interval[1] + ")";
		}

		mBindMap.put(key, new ParamObject(key, description, paramValue, type, choices, interval));
	}

	@Override
	public void onSaveInstanceState(Bundle outState) {
		if (outState != null) {
			super.onSaveInstanceState(outState);
		}
	}

	@Override
	public void onResume() {

		switchString = resources.getStringArray(R.array.bfswitchString);

		// AppCache.setScanEnable(false);

		if (dialog != null) {
			dialog.dismiss();
			dialog = null;
		}
		loadParams();
		if (mAdapter != null) {
			mAdapter.notifyDataSetChanged();
		}
		super.onResume();
	}

	@Override
	public void onPause() {

		if (dialogSet != null && dialogSet.isShowing()) {
			dialogSet.cancel();
		}

		// AppCache.setScanEnable(true);
		super.onPause();
	}

	@Override
	public void onDestroy() {
		if (dialog != null) {
			dialog.cancel();
		}
		super.onDestroy();
	}

	class ExpandAdapter extends BaseExpandableListAdapter {

		@Override
		public Object getChild(int groupPosition, int childPosition) {

			ParamObject object;
			synchronized (groupMap) {
				object = mBindMap.get(groupMap.get(group[groupPosition]).keyAt(childPosition));
			}

			return object;
		}

		@Override
		public long getChildId(int groupPosition, int childPosition) {
			return childPosition;
		}

		@Override
		public View getChildView(int groupPosition, int childPosition, boolean isLastChild, View convertView,
				ViewGroup parent) {

			return getChildViewByParam(convertView, groupPosition, childPosition);
		}

		@Override
		public int getChildrenCount(int groupPosition) {
			SparseArray<String> temArray;
			synchronized (groupMap) {
				temArray = groupMap.get(group[groupPosition].toString());
				Log.d(LOG_TAG, "" + temArray.size());
			}
			return temArray.size();
		}

		@Override
		public Object getGroup(int groupPosition) {
			return group[groupPosition];
		}

		@Override
		public int getGroupCount() {
			return group.length;
		}

		@Override
		public long getGroupId(int groupPosition) {
			return groupPosition;
		}

		@Override
		public View getGroupView(int groupPosition, boolean isExpanded, View convertView, ViewGroup parent) {
			convertView = LayoutInflater.from(mContext).inflate(R.layout.group_parentitem_layout, null);

			TextView text = (TextView) convertView.findViewById(R.id.txt_parent);
			text.setText(group[groupPosition].toString());

			return convertView;
		}

		@Override
		public boolean hasStableIds() {
			return true;
		}

		@Override
		public boolean isChildSelectable(int groupPosition, int childPosition) {
			return true;
		}

		public View getChildViewByParam(View convertView, int groupPosition, int childPosition) {

			synchronized (groupMap) {
				ParamObject object;
				TextView text;
				object = mBindMap.get(groupMap.get(group[groupPosition]).keyAt(childPosition));
				if (convertView == null) {
					text = new TextView(mContext);
					AbsListView.LayoutParams lp = new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT,
							ViewGroup.LayoutParams.WRAP_CONTENT);
					text = new TextView(mContext);

					text.setTextSize(17);
					text.setTextColor(0xff0000CD);
					text.setPadding(30, 4, 0, 4);
					text.setLayoutParams(lp);
					convertView = text;
				} else {
					text = (TextView) convertView;
				}

				String result = null;
				try {
					switch (object.getType()) {
					case NUMERICTEXT:
						result = object.getValue() + "";
						break;
					case SWITCH:
						if (object.getValue() > -1) {
							result = switchString[object.getValue()];
						}
						break;
					case SINGLECHOICE:
						int value = object.getValue();
						if (object.getInterval() != null) {
							for (int i = 0, length = object.getInterval().length; i < length; i++) {
								if (value == object.getInterval()[i]) {
									result = object.getChoices()[i];
									// Log.d(LOG_TAG,"re:"+result+" in:"+value);
									break;
								}
							}
						} else {
							result = object.getChoices()[object.getValue()];
						}
						break;
					default:
						break;
					}
				} catch (Exception ex) {
					object = null;
					// Log.d(LOG_TAG," !");
				}
				String resultText = null;
				if (object.getType() == ParamObject.ViewType.DEFAULT) {
					resultText = "|--   " + FontUtil.getSpannedString(object.getDescription());
				} else {
					resultText = "|--   " + object.getDescription() + ":&nbsp;"
							+ FontUtil.getSpannedString((result == null ? "Error" : result));
				}
				Spanned spanned = Html.fromHtml(resultText);
				text.setText(spanned);
			}
			return convertView;
		}
	}

	static boolean onshowing = false;

	AlertDialog dialogSet;

	class ChildClickListener implements ExpandableListView.OnChildClickListener {
		@Override
		public boolean onChildClick(ExpandableListView parent, View v, int groupPosition, int childPosition, long id) {
			childObject = mBindMap.get(groupMap.get(group[groupPosition]).keyAt(childPosition));
			if (dialogSet == null || !dialogSet.isShowing()) {
				dialogSet = getDialog(childObject);
				dialogSet.show();
			}
			return false;
		}

		private AlertDialog getDialog(ParamObject object) {

			AlertDialog dialog = null;
			inputText = null;
			switch (object.getType()) {

			case NUMERICTEXT:
				inputText = new EditText(mContext);
				inputText.setText(childObject.getValue() + "");
				inputText.setLayoutParams(new ActionBar.LayoutParams(ActionBar.LayoutParams.MATCH_PARENT,
						ActionBar.LayoutParams.MATCH_PARENT));
				dialog = new AlertDialog.Builder(mContext).setTitle(childObject.getDescription()).setView(inputText)
						.setNeutralButton("OK", clickListener).create();
				break;

			case SWITCH:
				clickListener.selectIndex = childObject.getValue();
				dialog = new AlertDialog.Builder(mContext).setTitle(childObject.getDescription())
						.setSingleChoiceItems(switchString, clickListener.selectIndex, clickListener)
						.setNeutralButton("OK", clickListener).create();
				break;

			case SINGLECHOICE:
				if (childObject.getInterval() != null) {
					for (int i = 0, length = childObject.getInterval().length; i < length; i++) {
						if (childObject.getInterval()[i] == childObject.getValue()) {
							clickListener.selectIndex = i;
							break;
						}
					}
				} else {
					clickListener.selectIndex = childObject.getValue();
					clickListener.result = childObject.getValue();
				}
				dialog = new AlertDialog.Builder(mContext).setTitle(childObject.getDescription())
						.setSingleChoiceItems(childObject.getChoices(), clickListener.selectIndex, clickListener)
						.setNeutralButton("OK", clickListener).create();

				break;
			default:
				break;
			}
			return dialog;
		}
	}

	class DismissListener implements DialogInterface.OnDismissListener {

		@Override
		public void onDismiss(DialogInterface dialog) {
			onshowing = false;
		}

	}

	class ClickListener implements DialogInterface.OnClickListener {

		public int selectIndex;
		private int result = 0;

		@Override
		public void onClick(DialogInterface dialog, int which) {
			if (which > -1) {
				selectIndex = which;
			} else {
				if (which == DialogInterface.BUTTON_NEUTRAL) {
					if (inputText != null) {
						try {
							int temp = Integer.parseInt(inputText.getText().toString());
							int min = childObject.getInterval()[0];
							int max = childObject.getInterval()[1];

							if (temp < min || temp > max) {
								throw new Exception();
							}

							result = temp;
						} catch (Exception ex) {
							Toast.makeText(mContext, resources.getString(R.string.bfInputPromptRange),
									Toast.LENGTH_SHORT).show();
							closeDialog(dialog, false);
							return;
						}
					} else if (childObject.getChoices() != null && childObject.getInterval() != null) {
						result = childObject.getInterval()[selectIndex];

						if (childObject.getId() == IScanner.ParamCode.OCR_TEMPLATE) { /*
																						 * {
																						 * 
																						 * if
																						 * (mScanner
																						 * instanceof
																						 * HHPScanner
																						 * &&
																						 * result
																						 * ==
																						 * 1)
																						 * {
																						 * 
																						 * final
																						 * EditText
																						 * editText
																						 * =
																						 * new
																						 * EditText
																						 * (
																						 * mContext
																						 * )
																						 * ;
																						 * editText
																						 * .
																						 * setLayoutParams
																						 * (
																						 * new
																						 * ActionBar
																						 * .
																						 * LayoutParams(
																						 * android
																						 * .
																						 * view
																						 * .
																						 * ViewGroup
																						 * .
																						 * LayoutParams
																						 * .
																						 * MATCH_PARENT,
																						 * android
																						 * .
																						 * view
																						 * .
																						 * ViewGroup
																						 * .
																						 * LayoutParams
																						 * .
																						 * MATCH_PARENT
																						 * )
																						 * )
																						 * ;
																						 * 
																						 * dialogSet
																						 * =
																						 * new
																						 * AlertDialog
																						 * .
																						 * Builder
																						 * (
																						 * mContext)
																						 * .setTitle(
																						 * resources
																						 * .getString
																						 * (
																						 * R
																						 * .
																						 * string
																						 * .
																						 * bfCustomTemplate
																						 * )
																						 * )
																						 * .setView
																						 * (
																						 * editText)
																						 * .setPositiveButton(
																						 * resources
																						 * .getString
																						 * (
																						 * R
																						 * .
																						 * string
																						 * .
																						 * bfOK
																						 * )
																						 * ,
																						 * new
																						 * OnClickListener
																						 * (
																						 * )
																						 * {
																						 * 
																						 * @Override
																						 * public
																						 * void
																						 * onClick(
																						 * DialogInterface
																						 * dialog,
																						 * int
																						 * which)
																						 * {
																						 * if
																						 * (which
																						 * ==
																						 * DialogInterface
																						 * .
																						 * BUTTON_POSITIVE)
																						 * {
																						 * (
																						 * (
																						 * HHPScanner)
																						 * mScanner)
																						 * .setOCRTemplate
																						 * (
																						 * editText
																						 * .getText
																						 * (
																						 * )
																						 * .toString
																						 * (
																						 * )
																						 * )
																						 * ;
																						 * }
																						 * }
																						 * }
																						 * )
																						 * .
																						 * create
																						 * (
																						 * )
																						 * ;
																						 * dialogSet
																						 * .
																						 * setCanceledOnTouchOutside
																						 * (
																						 * false
																						 * )
																						 * ;
																						 * dialogSet
																						 * .
																						 * show
																						 * (
																						 * )
																						 * ;
																						 * }
																						 * }
																						 */
						}
					} else {
						result = selectIndex;
					}

					// if (childObject.getValue() != result) {

					scanner.setParams(childObject.getId(), result, connectThread,
							new FragmentScanner.SettingCallBack() {
								ParamObject paramObject = childObject;

								@Override
								public void callback(int i) {
									if (i == D400Helper.SETTINGSECCESS) {
										paramObject.setValue(result);
										mAdapter.notifyDataSetChanged();
									} else if (i == D400Helper.SETTINGFAIL) {
										Toast.makeText(mContext, paramObject.getDescription() + "设置失败，请检查重试!",
												Toast.LENGTH_SHORT).show();
									}
								}
							});
					// }
					closeDialog(dialog, true);
				}
				onshowing = false;
			}
		}

		private void closeDialog(DialogInterface dialog, boolean close) {
			if (close) {
				onshowing = false;
			}
			Field field;
			try {
				field = dialog.getClass().getSuperclass().getDeclaredField("mShowing");
				field.setAccessible(true);
				field.set(dialog, close);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}

	public void refresh() {

		loadParams();
	}

}
